<?php

function cmd_tag_generate($construct_id, $id, $table, $tkey, $keyword = "") {
 global $T_TYPE, $TAG_PREFIX, $LANGUAGE;
 $sql = "SELECT keyword, dicuser.value,autoenable FROM construct LEFT JOIN dicuser ON (construct.name_id = dicuser.output_id AND dicuser.language_id = " . sqlf_tl_num($LANGUAGE) . ") WHERE construct.id = " . sqlf_tl_num($construct_id);
 $rs = query($sql, true); 
 if (!$keyword)
 $keyword = $rs["arr"][0]["keyword"];
 if ($table == "objtag") {
 $sql = "SELECT obj_type, obj_id FROM objtag WHERE id = " . sqlf_tl_num($id);
 $rs = query($sql, true); 
 $keyword = $T_TYPE[$rs["arr"][0]["obj_type"]]["key"] . "." . $keyword;
 }
 $cname = $rs["arr"][0]["value"];
 $autoenable = $rs["arr"][0]["autoenable"];
 $i = 1;
 if ($table == "contenttag") {
 $page = get_pageinfo($id);
 $template_id = $page["tid"];
 $content_id = $page["cid"];
 }
 if ($table == "templatetag")
 $template_id = $id;
 while (!$found) {
 
 if ($table == "objtag") {
 $sql = "SELECT obj_type, obj_id FROM objtag WHERE id = " . sqlf_tl_num($id);
 $rs_tmp = query($sql, true); 
 $obj_type = $rs_tmp["arr"][0]["obj_type"];
 $obj_id = $rs_tmp["arr"][0]["obj_id"];
 $sql = "SELECT count(id) AS c FROM " . sqlf_table($table) . "
			WHERE name = '" . sqlf_escaped(sqlslashes($keyword) . "$i") . "' AND obj_id = " . sqlf_tl_num($obj_id) . " AND obj_type = " . sqlf_tl_num($obj_type);
 $rst = query($sql); 
 }
 
 if ($table == "contenttag") {
 $sql = "SELECT count(id) AS c FROM " . sqlf_table($table) . " WHERE name = '" . sqlf_escaped(sqlslashes($keyword) . "$i") . "' AND content_id = " . sqlf_tl_num($content_id);
 $rs = query($sql); 
 if ($rs["arr"][0]["c"] == 0) {
 $sql = "SELECT count(id) AS c FROM templatetag WHERE name = '" . sqlf_escaped(sqlslashes($keyword) . "$i") . "' AND template_id = " . sqlf_tl_num($template_id);
 $rst = query($sql); 
 }
 }
 
 if ($table == "templatetag") {
 $sql = "SELECT count(id) AS c FROM " . sqlf_table($table) . " WHERE name = '" . sqlf_escaped(sqlslashes($keyword) . "$i") . "' AND template_id = " . sqlf_tl_num($template_id);
 $rs = query($sql); 
 if ($rs["arr"][0]["c"] == 0) {
 $rst = query("SELECT count(contenttag.id) c FROM contenttag" . " JOIN page on page.content_id = contenttag.content_id" . " WHERE page.template_id = " . sql_num($template_id) . "   AND contenttag.name = " . sql_str($keyword . "$i"));
 }
 }
 if ($rs["arr"][0]["c"] > 0 || $rst["arr"][0]["c"] > 0)
 $i++;
 else
 $found = true;
 }
 $f_newtag = "<$TAG_PREFIX $keyword$i>";
 $tmpname = $keyword . $i;
 if ($tkey == "template")
 $o_id = $id;
 else
 if ($tkey == "content") {
 $sql = "SELECT content_id FROM page WHERE id = " . sqlf_tl_num($id);
 $rs = query($sql); 
 $o_id = $rs["arr"][0]["content_id"];
 }
 else
 if ($tkey == "obj") {
 $sql = "SELECT obj_id, obj_type FROM objtag WHERE id = " . sqlf_tl_num($id);
 $rs = query($sql); 
 $o_id[$rs["arr"][0]["obj_id"]] = $rs["arr"][0]["obj_type"];
 $intag = $id;
 }
 else {
 $o_id = 0;
 $intag = 0;
 }
 if (!$o_id)
 halt(7, "tag_fill: unable to create intag tag: tkey($tkey), tmpname($tmpname), o_id($o_id), id($id)");
 $newState = $autoenable ? 1 : 3;
 $iid = tag_create($tmpname, $o_id, $tkey, $construct_id, 0, $newState, $intag);
 $tmp = Array ();
 $tmp["id"] = $iid;
 $tmp["name"] = $f_newtag;
 $tmp["tagname"] = $tmpname;
 return $tmp;
}

function tag_create($name, $oid, $type, $cid = 1, $pub = 0, $enabled = 3, $intag = 0, $part_limitation = Array ()) {
 global $W_CREATE, $T_TAG, $T_TEMPLATETAG, $T_CONTENTTAG, $T_OBJECTTAG;
 $tag_ttype = null;
 if ($type != "obj" && $type != "template" && $type != "content")
 halt(7, "tag_create: this type is not yet supported type($type)");
 $name = sqlslashes($name);
 if ($type == "template") {
 $tag_ttype = $T_TEMPLATETAG;
 $tpl = get_templateinfo($oid);
 $sql = "SELECT id FROM templatetag WHERE name = '" . sqlf_escaped($name) . "' AND template_id = " . sqlf_tl_num($oid);
 $rs = query($sql); 
 if ($rs["num"] > 0) {
 return $rs["arr"][0]["id"];
 }
 $sql = "INSERT INTO templatetag (name,templategroup_id,construct_id,template_id,pub,enabled)
		VALUES ('" . sqlf_escaped($name) . "'," . sqlf_tl_num($tpl["templategroup_id"]) . "," . sqlf_tl_num($cid) . "," . sqlf_tl_num($oid) . "," . sqlf_tl_num($pub) . "," . sqlf_tl_num($enabled) . ")";
 }
 if ($type == "content") {
 $tag_ttype = $T_CONTENTTAG;
 $sql = "SELECT id FROM contenttag WHERE name = '" . sqlf_escaped($name) . "' AND content_id = " . sqlf_tl_num($oid);
 $rs = query($sql); 
 if ($rs["num"] > 0)
 return $rs["arr"][0]["id"];
 $sql = "INSERT INTO contenttag (name,content_id,construct_id,enabled)
		VALUES ('" . sqlf_escaped($name) . "'," . sqlf_tl_num($oid) . "," . sqlf_tl_num($cid) . "," . sqlf_tl_num($enabled) . ")";
 }
 if ($type == "obj") {
 $tag_ttype = $T_OBJECTTAG;
 list ($obj_id, $obj_type) = each($oid);
 $sql = "SELECT id FROM objtag WHERE name = '" . sqlf_escaped($name) . "' AND obj_id = " . sqlf_tl_num($obj_id) . " AND obj_type = " . sqlf_tl_num($obj_type);
 $rs = query($sql); 
 if ($rs["num"] > 0)
 return $rs["arr"][0]["id"];
 $sql = "INSERT INTO objtag (obj_id,obj_type,construct_id,enabled,name,intag) VALUES
		(" . sqlf_tl_num($obj_id) . "," . sqlf_tl_num($obj_type) . "," . sqlf_tl_num($cid) . "," . sqlf_tl_num($enabled) . ",'" . sqlf_escaped($name) . "'," . sqlf_tl_num($intag) . ")";
 }
 $rs = query($sql); 
 $tag_id = $rs["iid"];
 
 set_tag_default($tag_id, $type, 0, $part_limitation);
 if ($type == "content") {
 global $T_CONTENTTAG;
 $tt = $T_CONTENTTAG;
 
 }
 triggerEvent($tag_ttype, $tag_id, EVENT_CREATE, new EventObject());
 
 return $rs["iid"];
}




function tag_tpldef($id, $constructId, $isEditableInPage, $isMandatory=0) {

 if (!$constructId) {
 halt(7, "tag_tpldef: invalid cid($constructId)");
 }

 global $C_DS, $FEATURE, $T_TEMPLATETAG;
 $modified = false;

 $sql = "UPDATE templatetag"
 . " SET pub=" . sqlf_tl_num((int)$isEditableInPage) . ", mandatory=" . sqlf_tl_num((int)$isMandatory)
 . " WHERE id=" . sqlf_tl_num($id);

 $rs = query($sql); 
 $modified = ($rs["num"] > 0);
 





 $sql = "SELECT contenttag.construct_id, contenttag.id FROM templatetag, page, contenttag
	          WHERE templatetag.template_id = page.template_id AND page.content_id = contenttag.content_id AND
	                contenttag.name = templatetag.name AND templatetag.id = " . sqlf_tl_num($id);
 $rs = query($sql); 
 if ($rs["arr"]) {
 while (list ($key, $val) = each($rs["arr"])) {
 $old_cid = $val["construct_id"];
 if ($old_cid != $constructId) {
 
 tag_transform($val["id"], "content", $constructId, $old_cid);
 }
 }
 }
 $sql = "SELECT templatetag.construct_id FROM templatetag WHERE id=" . sqlf_tl_num($id);
 $rs = query($sql); 
 if ($rs["num"] == 0)
 halt(7, "tag_tpldef: templatetag ($id) does not exists");
 $old_cid = $rs["arr"][0]["construct_id"];
 if ($old_cid != $constructId)
 tag_transform($id, "template", $constructId, $old_cid);
 if ($modified && $FEATURE["javaparser"]) {
 
 $javaParser = & CodeParser :: getJavaParser();
 $javaParser->clearCache($T_TEMPLATETAG, $id);
 }
}

function tag_transform($id, $type, $cid, $old_cid) {
 global $SQLAS;
 if (!$id || ($type != "content" && $type != "template") || !$cid || !$old_cid)
 halt(7, "tag_transform: invalid parameters: id($id) type($type) cid($cid) old_cid($old_cid)");
 
 





 $sql = "SELECT oldpart.id AS oldpid, newpart.id AS newpid, oldpart.type_id AS oldtype_id, newpart.type_id AS newtype_id
	FROM part $SQLAS oldpart, part $SQLAS newpart
	WHERE oldpart.keyword = newpart.keyword
	AND oldpart.construct_id = " . sqlf_tl_num($old_cid) . " AND newpart.construct_id = " . sqlf_tl_num($cid) . "
	AND oldpart.keyword != '' AND newpart.keyword != ''";
 $rs = query($sql); 
 $where = "";
 $texttypes = Array (
 1,
 2,
 3,
 4,
 9,
 10,
 15,
 16,
 17,
 21
 );
 
 if (is_array($rs["arr"]))
 while (list ($k, $v) = each($rs["arr"])) {
 if ($v["oldtype_id"] == $v["newtype_id"] || (in_array($v["oldtype_id"], $texttypes) && in_array($v["newtype_id"], $texttypes))) {
 $sql = "UPDATE value SET part_id = " . sqlf_tl_num($v["newpid"]) . " WHERE part_id = " . sqlf_tl_num($v["oldpid"]) . " AND " . sqlf_field($type . "tag_id") . " = " . sqlf_tl_num($id);
 query($sql); 
 
 $where .= " AND part_id != " . sqlf_tl_num($v["newpid"]);
 }
 }
 
 $sql = "DELETE FROM value WHERE " . sqlf_field($type . "tag_id") . " = " . sqlf_tl_num($id) . " AND static = 0$where";
 query($sql); 
 
 $sql = "SELECT enabled FROM " . sqlf_field($type . "tag") . " WHERE id = " . sqlf_tl_num($id);
 $rs = query($sql); 
 if ($rs["arr"][0]["enabled"] == 3) {
 $sql = "SELECT autoenable FROM construct WHERE id = " . sqlf_tl_num($cid);
 $rs = query($sql); 
 if ($rs["arr"][0]["autoenable"]) {
 $sql = "UPDATE " . sqlf_field($type . "tag") . " SET enabled = 1 WHERE id = " . sqlf_tl_num($id);
 query($sql); 
 }
 }
 
 $sql = "UPDATE " . sqlf_field($type . "tag") . " SET construct_id = " . sqlf_tl_num($cid) . " WHERE id = " . sqlf_tl_num($id);
 query($sql); 
 
 set_tag_default($id, $type, $old_cid);
}

function set_tag_default($tid, $type, $oldcid = 0, $part_limitation = Array ()) {
 global $SQLAS;
 if ($type != "obj" && $type != "content" && $type != "template" && $type != "global")
 halt(7, "set_tag_default: not supportet or missing \$type($type)");
 if ($type == "obj")
 return;
 
 $type = sqlf_name($type);
 $sql = "SELECT part.keyword, part_id, info, static, value_text, value_ref, part.construct_id FROM value, part, " . $type . "tag 
	WHERE value.part_id = part.id AND part.construct_id = " . $type . "tag.construct_id AND " . $type . "tag.id = " . sqlf_tl_num($tid) . " AND static = 0
	AND value.globaltag_id = 0 AND value.templatetag_id = 0 AND value.contenttag_id = 0 AND value.objtag_id = 0";
 $rs = query($sql); 
 $default_values = $rs["arr"];
 
 if (is_array($default_values))
 while (list ($k, $v) = each($default_values)) {
 
 if ($part_limitation && !$part_limitation[$v["part_id"]])
 continue;
 $part_id = $v["part_id"];
 $default_info = $v["info"];
 $static = $v["static"];
 
 
 
 $default_value_text = $v["value_text"];
 $default_value_ref = $v["value_ref"];
 $newcid = $v["construct_id"];
 
 $sql = "SELECT value.part_id, value.info, value.value_ref, value.value_text FROM value
			WHERE value." . $type . "tag_id = " . sqlf_tl_num($tid) . " AND value.part_id = " . sqlf_tl_num($part_id);
 $rs = query($sql); 
 $value_text = $rs["arr"][0]["value_text"];
 $value_ref = $rs["arr"][0]["value_ref"];
 $info = $rs["arr"][0]["info"];
 if ($rs["num"] == 0) {
 
 cmd_insert_value($default_value_text, $default_value_ref, $default_info, $type, $tid, $part_id, $static, false, false);
 
 }
 else
 if ($rs["num"] == 1) {
 if ($oldcid) {
 $newpid = $rs["arr"][0]["part_id"];
 
 $sql = "SELECT part.keyword, info, value_text, value_ref FROM value, part, part $SQLAS newpart
						WHERE value.part_id = part.id AND part.construct_id = " . sqlf_tl_num($oldcid) . " 
						AND static = 0 AND value.globaltag_id = 0 AND value.templatetag_id = 0 AND contenttag_id = 0 AND value.objtag_id = 0
						AND part.keyword = newpart.keyword AND part.type_id = newpart.type_id AND newpart.construct_id = " . sqlf_tl_num($newcid) . "
						AND part.keyword != '' AND newpart.id = " . sqlf_tl_num($newpid);
 $rs = query($sql); 
 $row = $rs["arr"][0];
 
 
 if ($row["info"] == $info && $row["value_ref"] == $value_ref && $row["value_text"] == $value_text) {
 cmd_update_value($default_value_text, $default_value_ref, $default_info, $type, $tid, FALSE, $part_id, false, false, false);
 }
 }
 }
 else
 halt(7, "set_tag_default: retrieved more than one(" . $rs["num"] . ") value for a part_id($part_id)");
 }
}






function cmd_tagpart_touch($type, $id, $obj_type = CT_FILE) {
 global $T_CONTENT, $T_CONTENTTAG, $T_TEMPLATETAG;
 if (!$id)
 halt(7, "cmd_tagpart_sync: invalid id($id)");
 if ($type == $T_CONTENT) {
 $table = "contenttag";
 $tablekey = "content_id";
 }
 else
 if ($type == $T_CONTENTTAG) {
 $table = "contenttag";
 $tablekey = "id";
 }
 else
 if ($type == $T_TEMPLATETAG) {
 $table = "templatetag";
 $tablekey = "id";
 }
 else
 if ($type == T_OBJTAG) {
 $type = 'obj';
 $table = "objtag";
 $tablekey = "obj_id";
 $obj_sql = " AND $table.obj_type = '" . sqlf_escaped($obj_type) . "' ";
 }
 else
 halt(7, "cmd_tagpart_sync: invalid type($type)");
 $table = sqlf_table($table);
 $tablekey = sqlf_field($tablekey);
 $sql = "SELECT $table.id, part.id AS partid, $table.name FROM $table, part WHERE $table.$tablekey = " . sqlf_tl_num($id) . " $obj_sql AND part.construct_id = $table.construct_id AND part.editable > 0";
 $rs = query($sql); 
 while (list ($key, $val) = each($rs["arr"])) {
 $sql = "SELECT id FROM value WHERE " . $table . "_id = " . sqlf_tl_num($val["id"]) . " AND part_id = " . sqlf_tl_num($val["partid"]);
 $rsc = query($sql); 
 if ($rsc["num"] == 0) {
 cmd_insert_value("", false, false, $type, $val["id"], $val["partid"]);
 }
 }
}
